Index: trunk/source/Lib/TLibDecoder/TDecSbac.cpp
===================================================================
--- trunk/source/Lib/TLibDecoder/TDecSbac.cpp	(revision 443)
+++ trunk/source/Lib/TLibDecoder/TDecSbac.cpp	(revision 608)
@@ -2454,554 +2272,90 @@
 }
 
-Void TDecSbac::decodeFlush ( )
-{
-  UInt uiBit;
-  m_pcTDecBinIf->decodeBinTrm(uiBit);
-  m_pcTDecBinIf->flush();
-
-}
-
-#if HHI_DMM_WEDGE_INTRA || HHI_DMM_PRED_TEX || (LGE_EDGE_INTRA_A0070 && LGE_EDGE_INTRA_DELTA_DC)
-Void TDecSbac::xReadExGolombLevel( UInt& ruiSymbol, ContextModel& rcSCModel  )
-{
-  UInt uiSymbol;
-  UInt uiCount = 0;
-  do
-  {
-    m_pcTDecBinIf->decodeBin( uiSymbol, rcSCModel );
-    uiCount++;
-  }
-  while( uiSymbol && ( uiCount != 13 ) );
-
-  ruiSymbol = uiCount - 1;
+#if H_3D_ARP
+Void TDecSbac::parseARPW( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth )
+{
+  UInt uiMaxW = pcCU->getSlice()->getARPStepNum() - 1;
+  UInt uiW = 0;
+  UInt uiOffset = pcCU->getCTXARPWFlag(uiAbsPartIdx);
+  UInt uiCode = 0;
+
+  assert ( uiMaxW > 0 );
+
+  m_pcTDecBinIf->decodeBin( uiCode , m_cCUPUARPWSCModel.get( 0, 0, 0 + uiOffset ) );
+
+  uiW = uiCode;
+  if( 1 == uiW )   
+  {
+    m_pcTDecBinIf->decodeBin( uiCode , m_cCUPUARPWSCModel.get( 0, 0, 3 ) );
+    uiW += ( 1 == uiCode ? 1 : 0 );
+  }
+#if H_MV_ENC_DEC_TRAC
+  DTRACE_CU("iv_res_pred_weight_idx", uiW )
+#endif
+  pcCU->setARPWSubParts( ( UChar )( uiW ) , uiAbsPartIdx, uiDepth );  
+}
+#endif
+
+#if H_3D_IC
+/** parse illumination compensation flag
+ * \param pcCU
+ * \param uiAbsPartIdx 
+ * \param uiDepth
+ * \returns Void
+ */
+Void TDecSbac::parseICFlag( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth )
+{ 
+  UInt uiSymbol = 0;
+  UInt uiCtxIC = pcCU->getCtxICFlag( uiAbsPartIdx );
+  m_pcTDecBinIf->decodeBin( uiSymbol, m_cCUICFlagSCModel.get( 0, 0, uiCtxIC ) );
+#if !H_MV_ENC_DEC_TRAC 
+  DTRACE_CABAC_VL( g_nSymbolCounter++ );
+  DTRACE_CABAC_T( "\tICFlag" );
+  DTRACE_CABAC_T( "\tuiCtxIC: ");
+  DTRACE_CABAC_V( uiCtxIC );
+  DTRACE_CABAC_T( "\tuiSymbol: ");
+  DTRACE_CABAC_V( uiSymbol );
+  DTRACE_CABAC_T( "\n");
+#else
+  DTRACE_CU("ic_flag", uiSymbol)
+#endif
+  
+  pcCU->setICFlagSubParts( uiSymbol ? true : false , uiAbsPartIdx, 0, uiDepth );
+}
+#endif
+
+#if LGE_INTER_SDC_E0156
+Void TDecSbac::parseInterSDCFlag( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth )
+{
+  UInt uiSymbol = 0;
+  UInt uiCtxInterSDCFlag = pcCU->getCtxInterSDCFlag( uiAbsPartIdx );
+
+  m_pcTDecBinIf->decodeBin( uiSymbol, m_cInterSDCFlagSCModel.get( 0, 0, uiCtxInterSDCFlag ) );
 
   if( uiSymbol )
   {
-    xReadEpExGolomb( uiSymbol, 0 );
-    ruiSymbol += uiSymbol + 1;
-  }
-
-  return;
-}
-#endif
-#if HHI_DMM_WEDGE_INTRA
-Void TDecSbac::xParseWedgeFullInfo( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth )
-{
-  Int iIntraIdx = pcCU->getIntraSizeIdx(uiAbsPartIdx);
-  Int iBits = g_aucWedgeFullBitsListIdx[iIntraIdx];
-
-  UInt uiSymbol, uiTabIdx = 0;
-  for ( Int i = 0; i < iBits; i++ )
-  {
-    m_pcTDecBinIf->decodeBin( uiSymbol, m_cDmmDataSCModel.get(0, 0, 0) );
-    uiTabIdx += ( uiSymbol && i == 0 ) ? 1 : 0;
-    uiTabIdx += ( uiSymbol && i == 1 ) ? 2 : 0;
-    uiTabIdx += ( uiSymbol && i == 2 ) ? 4 : 0;
-    uiTabIdx += ( uiSymbol && i == 3 ) ? 8 : 0;
-    uiTabIdx += ( uiSymbol && i == 4 ) ? 16 : 0;
-    uiTabIdx += ( uiSymbol && i == 5 ) ? 32 : 0;
-    uiTabIdx += ( uiSymbol && i == 6 ) ? 64 : 0;
-    uiTabIdx += ( uiSymbol && i == 7 ) ? 128 : 0;
-    uiTabIdx += ( uiSymbol && i == 8 ) ? 256 : 0;
-    uiTabIdx += ( uiSymbol && i == 9 ) ? 512 : 0;
-    uiTabIdx += ( uiSymbol && i == 10 ) ? 1024 : 0;
-    uiTabIdx += ( uiSymbol && i == 11 ) ? 2048 : 0;
-    uiTabIdx += ( uiSymbol && i == 12 ) ? 4096 : 0;
-  }
-
-  pcCU->setWedgeFullTabIdxSubParts( uiTabIdx, uiAbsPartIdx, uiDepth );
-}
-
-Void TDecSbac::xParseWedgeFullDeltaInfo( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth )
-{
-  Int iIntraIdx = pcCU->getIntraSizeIdx(uiAbsPartIdx);
-  Int iBits = g_aucWedgeFullBitsListIdx[iIntraIdx];
-
-  UInt uiSymbol, uiTabIdx = 0;
-  for ( Int i = 0; i < iBits; i++ )
-  {
-    m_pcTDecBinIf->decodeBin( uiSymbol, m_cDmmDataSCModel.get(0, 0, 0) );
-    uiTabIdx += ( uiSymbol && i == 0 ) ? 1 : 0;
-    uiTabIdx += ( uiSymbol && i == 1 ) ? 2 : 0;
-    uiTabIdx += ( uiSymbol && i == 2 ) ? 4 : 0;
-    uiTabIdx += ( uiSymbol && i == 3 ) ? 8 : 0;
-    uiTabIdx += ( uiSymbol && i == 4 ) ? 16 : 0;
-    uiTabIdx += ( uiSymbol && i == 5 ) ? 32 : 0;
-    uiTabIdx += ( uiSymbol && i == 6 ) ? 64 : 0;
-    uiTabIdx += ( uiSymbol && i == 7 ) ? 128 : 0;
-    uiTabIdx += ( uiSymbol && i == 8 ) ? 256 : 0;
-    uiTabIdx += ( uiSymbol && i == 9 ) ? 512 : 0;
-    uiTabIdx += ( uiSymbol && i == 10 ) ? 1024 : 0;
-    uiTabIdx += ( uiSymbol && i == 11 ) ? 2048 : 0;
-    uiTabIdx += ( uiSymbol && i == 12 ) ? 4096 : 0;
-  }
-
-  pcCU->setWedgeFullTabIdxSubParts( uiTabIdx, uiAbsPartIdx, uiDepth );
-
-  UInt uiDC1, uiDC2;
-  xReadExGolombLevel( uiDC1, m_cDmmDataSCModel.get(0, 0, 1) );
-  Int iDC1 = uiDC1;
-  if ( uiDC1 )
-  {
-    UInt uiSign;
-    m_pcTDecBinIf->decodeBinEP( uiSign );
-    if ( uiSign )
-    {
-      iDC1 = -iDC1;
-    }
-  }
-  xReadExGolombLevel( uiDC2, m_cDmmDataSCModel.get(0, 0, 1) );
-  Int iDC2 = uiDC2;
-  if ( uiDC2 )
-  {
-    UInt uiSign;
-    m_pcTDecBinIf->decodeBinEP( uiSign );
-    if ( uiSign )
-    {
-      iDC2 = -iDC2;
-    }
-  }
-
-  pcCU->setWedgeFullDeltaDC1SubParts( iDC1, uiAbsPartIdx, uiDepth );
-  pcCU->setWedgeFullDeltaDC2SubParts( iDC2, uiAbsPartIdx, uiDepth );
-}
-
-Void TDecSbac::xParseWedgePredDirInfo( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth )
-{
-  if( DMM_WEDGE_PREDDIR_DELTAEND_MAX > 0 )
-  {
-    UInt uiDeltaEnd = 0;
-    m_pcTDecBinIf->decodeBin( uiDeltaEnd, m_cDmmDataSCModel.get(0, 0, 2) );
-
-    Int iDeltaEnd;
-    if( uiDeltaEnd != 0 )
-    {
-      UInt uiAbsValMinus1;
-      UInt uiSymbol;
-      m_pcTDecBinIf->decodeBin( uiSymbol, m_cDmmDataSCModel.get(0, 0, 2) ); uiAbsValMinus1  = uiSymbol;
-      m_pcTDecBinIf->decodeBin( uiSymbol, m_cDmmDataSCModel.get(0, 0, 2) ); uiAbsValMinus1 |= uiSymbol << 1;
-      uiDeltaEnd = uiAbsValMinus1 + 1;
-
-      iDeltaEnd = uiDeltaEnd;
-      UInt uiSign;
-      m_pcTDecBinIf->decodeBinEP( uiSign );
-      if( uiSign )
-      {
-        iDeltaEnd = -iDeltaEnd;
-      }
-    }
-    else
-    {
-      iDeltaEnd = 0;
-    }
-    pcCU->setWedgePredDirDeltaEndSubParts( iDeltaEnd, uiAbsPartIdx, uiDepth );
-  }
-}
-
-Void TDecSbac::xParseWedgePredDirDeltaInfo( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth )
-{
-  if( DMM_WEDGE_PREDDIR_DELTAEND_MAX > 0 )
-  {
-    UInt uiDeltaEnd = 0;
-    m_pcTDecBinIf->decodeBin( uiDeltaEnd, m_cDmmDataSCModel.get(0, 0, 2) );
-
-    Int iDeltaEnd;
-    if( uiDeltaEnd != 0 )
-    {
-      UInt uiAbsValMinus1;
-      UInt uiSymbol;
-      m_pcTDecBinIf->decodeBin( uiSymbol, m_cDmmDataSCModel.get(0, 0, 2) ); uiAbsValMinus1  = uiSymbol;
-      m_pcTDecBinIf->decodeBin( uiSymbol, m_cDmmDataSCModel.get(0, 0, 2) ); uiAbsValMinus1 |= uiSymbol << 1;
-      uiDeltaEnd = uiAbsValMinus1 + 1;
-
-      iDeltaEnd = uiDeltaEnd;
-      UInt uiSign;
-      m_pcTDecBinIf->decodeBinEP( uiSign );
-      if( uiSign )
-      {
-        iDeltaEnd = -iDeltaEnd;
-      }
-    }
-    else
-    {
-      iDeltaEnd = 0;
-    }
-
-    pcCU->setWedgePredDirDeltaEndSubParts( iDeltaEnd, uiAbsPartIdx, uiDepth );
-  }
-
-  UInt uiDC1, uiDC2;
-  xReadExGolombLevel( uiDC1, m_cDmmDataSCModel.get(0, 0, 1) );
-  Int iDC1 = uiDC1;
-  if ( uiDC1 )
-  {
-    UInt uiSign;
-    m_pcTDecBinIf->decodeBinEP( uiSign );
-    if ( uiSign )
-    {
-      iDC1 = -iDC1;
-    }
-  }
-  xReadExGolombLevel( uiDC2, m_cDmmDataSCModel.get(0, 0, 1) );
-  Int iDC2 = uiDC2;
-  if ( uiDC2 )
-  {
-    UInt uiSign;
-    m_pcTDecBinIf->decodeBinEP( uiSign );
-    if ( uiSign )
-    {
-      iDC2 = -iDC2;
-    }
-  }
-
-  pcCU->setWedgePredDirDeltaDC1SubParts( iDC1, uiAbsPartIdx, uiDepth );
-  pcCU->setWedgePredDirDeltaDC2SubParts( iDC2, uiAbsPartIdx, uiDepth );
-}
-#endif
-#if HHI_DMM_PRED_TEX
-#if LGE_DMM3_SIMP_C0044
-Void TDecSbac::xParseWedgePredTexInfo( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth )
-{
-  Int iIntraIdx = pcCU->getIntraSizeIdx(uiAbsPartIdx);
-  Int iBits = g_aucWedgeTexPredBitsListIdx[iIntraIdx];
-
-  UInt uiSymbol, uiTabIdx = 0;
-  for ( Int i = 0; i < iBits; i++ )
-  {
-    m_pcTDecBinIf->decodeBin( uiSymbol, m_cDmmDataSCModel.get(0, 0, 3) );
-    uiTabIdx += ( uiSymbol && i == 0 ) ? 1 : 0;
-    uiTabIdx += ( uiSymbol && i == 1 ) ? 2 : 0;
-    uiTabIdx += ( uiSymbol && i == 2 ) ? 4 : 0;
-    uiTabIdx += ( uiSymbol && i == 3 ) ? 8 : 0;
-    uiTabIdx += ( uiSymbol && i == 4 ) ? 16 : 0;
-    uiTabIdx += ( uiSymbol && i == 5 ) ? 32 : 0;
-    uiTabIdx += ( uiSymbol && i == 6 ) ? 64 : 0;
-    uiTabIdx += ( uiSymbol && i == 7 ) ? 128 : 0;
-    uiTabIdx += ( uiSymbol && i == 8 ) ? 256 : 0;
-    uiTabIdx += ( uiSymbol && i == 9 ) ? 512 : 0;
-    uiTabIdx += ( uiSymbol && i == 10 ) ? 1024 : 0;
-  }
-
-  pcCU->setWedgePredTexIntraTabIdxSubParts( uiTabIdx, uiAbsPartIdx, uiDepth );
-}
-#endif
-
-Void TDecSbac::xParseWedgePredTexDeltaInfo( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth )
-{
-#if LGE_DMM3_SIMP_C0044
-  xParseWedgePredTexInfo( pcCU, uiAbsPartIdx, uiDepth );
-#endif
-  UInt uiDC1, uiDC2;
-  xReadExGolombLevel( uiDC1, m_cDmmDataSCModel.get(0, 0, 1) );
-  Int iDC1 = uiDC1;
-  if ( uiDC1 )
-  {
-    UInt uiSign;
-    m_pcTDecBinIf->decodeBinEP( uiSign );
-    if ( uiSign )
-    {
-      iDC1 = -iDC1;
-    }
-  }
-  xReadExGolombLevel( uiDC2, m_cDmmDataSCModel.get(0, 0, 1) );
-  Int iDC2 = uiDC2;
-  if ( uiDC2 )
-  {
-    UInt uiSign;
-    m_pcTDecBinIf->decodeBinEP( uiSign );
-    if ( uiSign )
-    {
-      iDC2 = -iDC2;
-    }
-  }
-
-  pcCU->setWedgePredTexDeltaDC1SubParts( iDC1, uiAbsPartIdx, uiDepth );
-  pcCU->setWedgePredTexDeltaDC2SubParts( iDC2, uiAbsPartIdx, uiDepth );
-}
-
-Void TDecSbac::xParseContourPredTexDeltaInfo( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth )
-{
-  UInt uiDC1, uiDC2;
-  xReadExGolombLevel( uiDC1, m_cDmmDataSCModel.get(0, 0, 1) );
-  Int iDC1 = uiDC1;
-  if ( uiDC1 )
-  {
-    UInt uiSign;
-    m_pcTDecBinIf->decodeBinEP( uiSign );
-    if ( uiSign )
-    {
-      iDC1 = -iDC1;
-    }
-  }
-  xReadExGolombLevel( uiDC2, m_cDmmDataSCModel.get(0, 0, 1) );
-  Int iDC2 = uiDC2;
-  if ( uiDC2 )
-  {
-    UInt uiSign;
-    m_pcTDecBinIf->decodeBinEP( uiSign );
-    if ( uiSign )
-    {
-      iDC2 = -iDC2;
-    }
-  }
-
-  pcCU->setContourPredTexDeltaDC1SubParts( iDC1, uiAbsPartIdx, uiDepth );
-  pcCU->setContourPredTexDeltaDC2SubParts( iDC2, uiAbsPartIdx, uiDepth );
-}
-#endif
-#if QC_ARP_D0177
-Void TDecSbac::parseARPW( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth )
-{
-  UInt nMaxW = pcCU->getSlice()->getARPStepNum() - 1;
-#if !QC_ARP_WARNING_FIX
-  assert (nMaxW >= 0);
-#endif
-  UInt nW = 0;
-  if( nMaxW > 0 )
-  {
-    UInt nOffset = pcCU->getCTXARPWFlag(uiAbsPartIdx);
-#if !QC_ARP_WARNING_FIX
-    assert( 0 <= nOffset && nOffset <= 2 );
-#endif
-    UInt uiCode = 0;
-    m_pcTDecBinIf->decodeBin( uiCode , m_cCUPUARPW.get( 0, 0, 0 + nOffset ) );
-    nW = uiCode;
-    if( nW == 1 )   
-    {
-      m_pcTDecBinIf->decodeBin( uiCode , m_cCUPUARPW.get( 0, 0, 3 ) );
-      nW += ( uiCode == 1 );
-    }
-  }
-  pcCU->setARPWSubParts( ( UChar )( nW ) , uiAbsPartIdx, uiDepth );  
-}
-#endif
-#if LGE_EDGE_INTRA_A0070
-Void TDecSbac::xParseEdgeIntraInfo( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth )
-{
-  UInt uiSymbol = 0;
-
-  // 1. Top(0) or Left(1)
-  UChar ucLeft;
-  m_pcTDecBinIf->decodeBinEP( uiSymbol );
-  ucLeft = uiSymbol;
-
-  // 2. Start position (lowest bit first)
-  UChar ucStart = 0;
-  for( UInt ui = 0; ui < 6 - uiDepth; ui++ )
-  {
-    m_pcTDecBinIf->decodeBinEP( uiSymbol );
-    ucStart |= (uiSymbol << ui);
-  }
-
-  // 3. Number of edges
-  UChar ucMax = 0;
-  for( UInt ui = 0; ui < 7 - uiDepth; ui++ )
-  {
-    m_pcTDecBinIf->decodeBinEP( uiSymbol );
-    ucMax |= (uiSymbol << ui);
-  }
-  ucMax++; // +1
-
-  // 4. Edges
-  UChar* pucSymbolList = (UChar*) xMalloc( UChar, 256 * LGE_EDGE_INTRA_MAX_EDGE_NUM_PER_4x4 );
-  UInt uiCtxEdgeIntra = pcCU->getCtxEdgeIntra( uiAbsPartIdx );
-  for( Int iPtr = 0; iPtr < ucMax; iPtr++ )
-  {
-    UChar ucEdge = 0;
-    UInt  uiReorderEdge = 0;
-    // Left-friendly direction
-    // 0 (   0deg) => 0
-    // 1 (  45deg) => 10
-    // 2 ( -45deg) => 110
-    // 3 (  90deg) => 1110
-    // 4 ( -90deg) => 11110
-    // 5 ( 135deg) => 111110
-    // 6 (-135deg) => 111111
-    // Right-friendly direction
-    // 0 (   0deg) => 0
-    // 1 ( -45deg) => 10
-    // 2 (  45deg) => 110
-    // 3 ( -90deg) => 1110
-    // 4 (  90deg) => 11110
-    // 5 (-135deg) => 111110
-    // 6 ( 135deg) => 111111
-    // refer to a paper "An efficient chain code with Huffman coding"
-    for( UInt ui = 0; ui < 6; ui++ )
-    {
-      m_pcTDecBinIf->decodeBin( uiSymbol, m_cEdgeIntraSCModel.get( 0, 0, uiCtxEdgeIntra ) );
-      ucEdge <<= 1;
-      ucEdge |= uiSymbol;
-      if( uiSymbol == 0 )
-        break;
-    }
-
-    switch( ucEdge )
-    {
-    case 0 :  // "0"
-      uiReorderEdge = 0;
-      break;
-    case 2 :  // "10"
-      uiReorderEdge = 1;
-      break;
-    case 6 :  // "110"
-      uiReorderEdge = 2;
-      break;
-    case 14 : // "1110"
-      uiReorderEdge = 3;
-      break;
-    case 30 : // "11110"
-      uiReorderEdge = 4;
-      break;
-    case 62 : // "111110"
-      uiReorderEdge = 5;
-      break;
-    case 63 : // "111111"
-      uiReorderEdge = 6;
-      break;
-    default :
-      printf("parseIntraEdgeChain: error (unknown code %d)\n",ucEdge);
-      assert(false);
-      break;
-    }
-    pucSymbolList[iPtr] = uiReorderEdge;
-  }
-  /////////////////////
-  // Edge Reconstruction
-  Bool* pbRegion = pcCU->getEdgePartition( uiAbsPartIdx );
-  pcCU->reconPartition( uiAbsPartIdx, uiDepth, ucLeft == 1, ucStart, ucMax, pucSymbolList, pbRegion );
-  xFree( pucSymbolList );
-}
-#endif
-  
-#if RWTH_SDC_DLT_B0036
-#if !PKU_QC_DEPTH_INTRA_UNI_D0195
-Void TDecSbac::parseSDCFlag( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth )
-{
-  assert( pcCU->getSlice()->getSPS()->isDepth() );
-  
-  UInt uiSymbol = 0;
-  UInt uiCtxSDCFlag = pcCU->getCtxSDCFlag( uiAbsPartIdx );
-  m_pcTDecBinIf->decodeBin( uiSymbol, m_cSDCFlagSCModel.get( 0, 0, uiCtxSDCFlag ) );
-  
-  if( uiSymbol == 1 )
-  {
-    pcCU->setPartSizeSubParts(SIZE_2Nx2N, uiAbsPartIdx, uiDepth);
-    
-    pcCU->setSDCFlagSubParts( true, uiAbsPartIdx, 0, uiDepth);
-    pcCU->setTrIdxSubParts(0, uiAbsPartIdx, uiDepth);
-    pcCU->setCbfSubParts(1, 1, 1, uiAbsPartIdx, uiDepth);
-  }
-}
-
-Void TDecSbac::parseSDCPredMode( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth )
-{
-  assert( pcCU->getSlice()->getSPS()->isDepth() );
-  assert( pcCU->getPartitionSize(uiAbsPartIdx) == SIZE_2Nx2N );
-  
-  assert( pcCU->getSDCFlag(uiAbsPartIdx) );
-  
-  UInt uiCtx            = 0;
-  
-  UInt uiMPModeIdx      = 0;
-  
-  for(Int i=0; i<RWTH_SDC_NUM_PRED_MODES-1; i++)
-  {
-    UInt uiIsMostProb = 0;
-#if INTEL_SDC64_D0193
-    if( !(pcCU->getWidth(uiAbsPartIdx) == 64 && i == 1))
-#endif
-    m_pcTDecBinIf->decodeBin( uiIsMostProb, m_cSDCPredModeSCModel.get( 0, i, uiCtx ) );
-    
-    if ( uiIsMostProb == 1 )
-      break;
-    
-    // else: get next most probable pred mode
-    uiMPModeIdx = (uiMPModeIdx+1)%RWTH_SDC_NUM_PRED_MODES;
-  }
-  
-  Int intraPredMode = g_auiSDCPredModes[uiMPModeIdx];
-  
-#if HHI_DMM_WEDGE_INTRA
-  if( intraPredMode == DMM_WEDGE_FULL_IDX )          { xParseWedgeFullInfo          ( pcCU, uiAbsPartIdx, uiDepth ); }
-  if( intraPredMode == DMM_WEDGE_PREDDIR_IDX )       { xParseWedgePredDirInfo       ( pcCU, uiAbsPartIdx, uiDepth ); }
-#endif
-  
-  pcCU->setLumaIntraDirSubParts((UChar)intraPredMode, uiAbsPartIdx, uiDepth);
-}
-#endif
-
-Void TDecSbac::parseSDCResidualData ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth, UInt uiSegment )
-{
-  assert( pcCU->getSlice()->getSPS()->isDepth() );
-  assert( pcCU->getSDCFlag(uiAbsPartIdx) );
-  assert( uiSegment < 2 );
-  
-  UInt uiResidual = 0;
-  UInt uiBit      = 0;
+    pcCU->setInterSDCFlagSubParts( true, uiAbsPartIdx, 0, uiDepth );
+    pcCU->setTrIdxSubParts( 0, uiAbsPartIdx, uiDepth );
+    pcCU->setCbfSubParts( 1, 1, 1, uiAbsPartIdx, uiDepth );
+  }
+  else
+  {
+    pcCU->setInterSDCFlagSubParts( false, uiAbsPartIdx, 0, uiDepth);
+  }
+}
+
+Void TDecSbac::parseInterSDCResidualData ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth, UInt uiSegment )
+{
   UInt uiAbsIdx   = 0;
   UInt uiSign     = 0;
   Int  iIdx       = 0;
-  
-  UInt uiMaxResidualBits  = pcCU->getSlice()->getSPS()->getBitsPerDepthValue();
-  assert( uiMaxResidualBits <= g_uiBitDepth );
-  
-#if RWTH_SDC_CTX_SIMPL_D0032
-  m_pcTDecBinIf->decodeBin(uiResidual, m_cSDCResidualFlagSCModel.get( 0, 0, 0 ) );
-#else
-  m_pcTDecBinIf->decodeBin(uiResidual, m_cSDCResidualFlagSCModel.get( 0, uiSegment, 0 ) );
-#endif
-  
-  if (uiResidual)
-  {
-    // decode residual sign bit
-#if RWTH_SDC_CTX_SIMPL_D0032
-    m_pcTDecBinIf->decodeBinEP(uiSign);
-#else
-    m_pcTDecBinIf->decodeBin(uiSign, m_cSDCResidualSignFlagSCModel.get( 0, uiSegment, 0 ) );
-#endif
-    
-    // decode residual magnitude
-#if LGE_CONCATENATE_D0141
-    //prefix part
-    UInt uiCount = 0;
-    UInt uiNumDepthValues = pcCU->getSlice()->getSPS()->getNumDepthValues();
-    UInt uiPrefixThreshold = ((uiNumDepthValues * 3) >> 2);
-    for ( UInt ui = 0; ui < uiPrefixThreshold; ui++)
-    {
-        m_pcTDecBinIf->decodeBin( uiBit, m_cSDCResidualSCModel.get(0, 0, 0) );
-        if ( uiBit == 0 )
-            break;
-        else
-            uiCount++;
-    }
-    //suffix part
-    if ( uiCount == uiPrefixThreshold )
-    {
-        for ( UInt ui = 0; ui < ( (UInt)ceil( Log2(uiNumDepthValues - uiPrefixThreshold) ) ); ui++ )
-        {
-            m_pcTDecBinIf->decodeBinEP( uiBit );
-            uiAbsIdx |= uiBit << ui;
-        }
-        uiAbsIdx += uiCount;
-    }
-    else
-        uiAbsIdx = uiCount;
-#else
-    for (Int i=0; i<uiMaxResidualBits; i++)
-    {
-#if RWTH_SDC_CTX_SIMPL_D0032
-      m_pcTDecBinIf->decodeBin(uiBit, m_cSDCResidualSCModel.get( 0, 0, i ) );
-#else
-      m_pcTDecBinIf->decodeBin(uiBit, m_cSDCResidualSCModel.get( 0, uiSegment, i ) );
-#endif
-      uiAbsIdx |= uiBit << i;
-    }
-#endif
-    
-    uiAbsIdx += 1;
-    iIdx =(Int)(uiSign ? -1 : 1)*uiAbsIdx;
-  }
-  
-  pcCU->setSDCSegmentDCOffset(iIdx, uiSegment, uiAbsPartIdx);
+
+  xReadExGolombLevel( uiAbsIdx, m_cInterSDCResidualSCModel.get( 0, 0, 0 ) );
+
+  uiAbsIdx++;
+  m_pcTDecBinIf->decodeBin( uiSign, m_cInterSDCResidualSignFlagSCModel.get( 0, 0, 0 ) );
+  iIdx = (Int)( uiSign ? -1 : 1 ) * uiAbsIdx;
+
+  pcCU->setInterSDCSegmentDCOffset( iIdx, uiSegment, uiAbsPartIdx );
 }
 #endif
